
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Calendar;
import java.util.ResourceBundle;

import javax.sound.midi.InvalidMidiDataException;
import javax.sound.midi.MidiUnavailableException;

import file.FileBrowser;

import sdljava.SDLException;
import sdljava.ttf.SDLTTF;
import sdljava.video.SDLSurface;
import sdljava.x.swig.Mix_Chunk;


public class User {

	private Piano piano;
	private boolean end ; //determina cuando salir del programa
	private boolean fullscreen ;
	
	//private Language language ;
	
	private SDLSurface screen;
	private Text text;
	
	private Text textArial15;
	private Text textArabica10;
	private Text textArabica8;
	private Text textCalculator20;
	private Text textCalculator40;
	
	private Text textCalculator15;
	
	private Text textHand20;
	
	private User user;
	
	//Key[] listKey;
	private Key[] listKey ; //objetos para las teclas blancas
	private Key[] listKeyblack ; //objetos para las teclas negras
	
	private Key[] listKeys ; //objetos para las teclas blancas
	
	private Mix_Chunk[] chunk;
	private Mix_Chunk[] chunkblack;
	   
	private Note[] listNote ; //objetos para las notas
	
	private CFrame frameNoteYellow;
	private CFrame frameNotePurple;
	private CFrame frameNotePink;
	private CFrame frameNoteRed;
	private CFrame frameNoteOrange;
	private CFrame frameNoteBlue;
	
	private CFrame frameWave1n1;
	private CFrame frameWave1n2;
	private CFrame frameWave1n3;
	private CFrame frameWave1n4;
	private CFrame frameWave1n5;
	private CFrame frameWave2n1;
	private CFrame frameWave2n2;
	private CFrame frameWave2n3;
	private CFrame frameWave2n4;
	private CFrame frameWave2n5;
	private CFrame frameWave3n1;
	private CFrame frameWave3n2;
	private CFrame frameWave3n3;
	private CFrame frameWave3n4;
	private CFrame frameWave3n5;
	
	private int submenu ;
	
	private CFrame frameBackgroundOptions;
	private CSprite spriteBackgroundOptions;
	
	private CFrame frameBackgroundSelectSong;
	private CSprite spriteBackgroundSelectSong;
	
	private 	CFrame frameBackgroundMain;
	private CSprite spriteBackgroundMain;
	
	private CFrame frameBackgroundNotebook;
	private CSprite spriteBackgroundNotebook;
	
	private CFrame frameHand;
	private CSprite spriteHand;
	
	private CSprite spriteWave;
	
	private CFrame frameNoteBorder;
	
	private CFrame frameKey;
	private CFrame frameKeyPush;
	private CFrame frameKeyblack;
	private CFrame frameKeyblackPush;
	private CFrame frameLine;
	
	private CFrame frameOk;
	private CFrame frameBad;
	private CFrame framePerfect;
	
	private CFrame frameStaff;
	private CSprite spriteStaff;
	
	private CFrame frameCrotchet;
	private CSprite spriteCrotchet;
	
	private CFrame frameNoteStaffwhole;
	private CFrame frameNoteStaffhalf;
	private CFrame frameNoteStaffquarter;
	private CFrame frameNoteStaffeighth;
	private CFrame frameNoteStaffsixteenth;

	private CFrame frameNoteStaffAuxLine;
	
	private CSprite spriteNoteStaff;
	
	private CFrame frameCrotchetBorder;
	private CSprite spriteCrotchetBorder;
	
	private CSprite spriteTemp ;
	private 	CSprite [] spritePrecision;
	
	private CSprite spriteNoteStaffAuxLine;
	
	private CSprite spriteNoteBorder;
	
	private CSprite spriteLine;
	private CSprite spriteNote;
	private 	CSprite spriteKey;
	private CSprite spriteKeyblack;
	
	private CFrame framebordercircleoff;
	private CFrame framebordercircleon;
	private CFrame frameborderoff;
	private CFrame frameborderon;
	private CFrame framebuttoncircle;
	private CFrame framebuttonoff;
	private 	CFrame framebuttonon;
	
	private 	CSprite spritebordercircle;
	private CSprite spriteborder;
	private 	CSprite spritebutton;
	private CSprite spritebuttoncircle;
	
	private CFrame framepencil;
	private CSprite spritepencil;
	
	private Keyboard keyboard;
	  
	private Midi[] midi;
	
	private int lastPrecision;
	private int lastNote; //variable que indica el ultimo objeto Nota usado
	private long inittime; //controla el numero de segundos actuales cuando es inicia el programa
	
	private long time; //controla el tiempo actual, reiniciado cuando obtiene una nota
	
	private int contPrecision ;
	private int channel;
	
	private  Calendar today ;

	private  String path;
    
	private  int maxtracks;
	private   int maxnotes;
	private    int maxkey;
	private   int maxprecision;
	private    int maxchannel;
    
	private  int maxoption;
	private   int maxmenu;
    
	private  int online;
    
	private   int maxusermenu;
    
	private   float tempo ; //multiplicador de tempo de la cancion
    
	private   FileBrowser filebrowser;
   
    
	private   int menuselectmusic;
	private  int menuprincipal;
    
	private   int numfile;
    
	private  Window window;
	private   MidiPlayer player;
	private    int numoption;
	private   int numuser;

	private   int menu;
    
	private  int nummenu;
    
	private   int pushKey;
    
	private   int staffmode;
    
	private   int actualwave;
    
	private  int interval;
    
    private int maxsubmenu;
	private   int frameskip;
	private    int frameskipmax;
	private   Score score;
    
	private   String song;
    
	private   String newusername;
	private   int shift =0;
    
	private   String [] scores = new String[10];
    
	private   Mix_Chunk [] sounds;
    
	private    int maxKeys;
	   public void initobjects() throws SDLException{
	    	
	    	 listKeys = new Key[maxKeys];
	 	   
	 	     for (int i=0;i<maxKeys;i++){

	 	    	listKeys[i] = new Key();
	 	    	
	 	    }
		     listNote = new Note[maxnotes]; //este máximo determina el número de notas simultaneas en funcionamiento
		  
		    for (int i=0;i<maxnotes;i++){


		    	listNote[i] = new Note();

		    }
	    	
	    }
	    
	    public void close(){
	    		
	    	//System.out.println("Gracias por jugar");
	    	if (fullscreen){
				screen.wmToggleFullScreen();
				fullscreen=!fullscreen;
	    	}
	    
	    }
		public void initsprites() throws SDLException, IOException{
			
	//init sprites
			

			framebordercircleoff= new CFrame();
			framebordercircleon= new CFrame();
			frameborderoff= new CFrame();
			frameborderon= new CFrame();
			framebuttoncircle= new CFrame();
			framebuttonoff= new CFrame();
			framebuttonon= new CFrame();
			
			spritebordercircle = new CSprite();
			spriteborder = new CSprite();
			spritebutton = new CSprite();
			spritebuttoncircle = new CSprite();
			
			frameBackgroundNotebook = new CFrame();
			spriteBackgroundNotebook = new CSprite() ;
			
			frameBackgroundOptions = new CFrame();
			spriteBackgroundOptions = new CSprite();
			
			frameBackgroundSelectSong = new CFrame();
			spriteBackgroundSelectSong = new CSprite();
			
			frameBackgroundMain = new CFrame();
			spriteBackgroundMain = new CSprite();
			
			frameHand = new CFrame();
			spriteHand = new CSprite();
			
			frameWave1n1 = new CFrame();
			frameWave1n2= new CFrame();
			frameWave1n3= new CFrame();
		    frameWave1n4= new CFrame();
			frameWave1n5= new CFrame();
		    frameWave2n1= new CFrame();
			frameWave2n2= new CFrame();
			frameWave2n3= new CFrame();
			frameWave2n4= new CFrame();
			frameWave2n5= new CFrame();
			frameWave3n1= new CFrame();
			frameWave3n2= new CFrame();
			frameWave3n3= new CFrame();
			frameWave3n4= new CFrame();
			frameWave3n5= new CFrame();
			
			spriteWave = new CSprite();
			
			frameNoteYellow = new CFrame();
		    frameNotePurple = new CFrame();
			frameNotePink= new CFrame();
			frameNoteRed= new CFrame();
			frameNoteOrange= new CFrame();
			frameNoteBlue= new CFrame();
		    
		    frameKey = new CFrame();
		    frameKeyblack = new CFrame();
		    
		    frameKeyPush = new CFrame();
		    frameKeyblackPush = new CFrame();
		    
		    frameLine = new CFrame();
		    
		    frameNoteBorder = new CFrame();
		    
			 frameOk= new CFrame();
			 frameBad= new CFrame();
			 framePerfect= new CFrame();
			 
			 frameCrotchet = new CFrame();
			 spriteCrotchet = new CSprite();
			 
			 frameCrotchetBorder = new CFrame();
			 spriteCrotchetBorder = new CSprite();
			 	 
			frameNoteStaffwhole = new CFrame();
			frameNoteStaffhalf = new CFrame();
			frameNoteStaffquarter = new CFrame();
			frameNoteStaffeighth = new CFrame();
			frameNoteStaffsixteenth = new CFrame();

			frameNoteStaffAuxLine = new CFrame();
			
			spriteNoteStaff  =new CSprite();
			 
			 frameStaff = new CFrame();
		    
			 spriteStaff = new CSprite();
			 
			 spritePrecision = new CSprite[10];

			spriteTemp =  new CSprite();
			 
		    spriteNoteBorder = new CSprite();
		    
		    spriteLine = new CSprite();
		    spriteNote= new CSprite();
		    spriteKey = new CSprite();
		    spriteKeyblack = new CSprite();
		    
		    spriteNoteStaffAuxLine = new CSprite();
		    
		    framepencil = new CFrame();
		    spritepencil  = new CSprite();
		    framepencil.load("sprites"+  File.separator +"pencil.png");
		    spritepencil.addframe(framepencil);
		    
			framebordercircleoff.load("sprites"+  File.separator + "bordercircleoff.png");
			framebordercircleon.load("sprites"+  File.separator + "bordercircleon.png");
			frameborderoff.load("sprites"+  File.separator + "borderoff.png");
			frameborderon.load("sprites"+  File.separator + "borderon.png");
			framebuttonoff.load("sprites"+  File.separator + "buttonoff.png");
			framebuttonon.load("sprites"+  File.separator + "buttonon.png");
			framebuttoncircle.load("sprites"+  File.separator + "buttoncircle.png");
			
			spritebordercircle.addframe(framebordercircleoff);
			spritebordercircle.addframe(framebordercircleon);
			spriteborder.addframe(frameborderoff);
			spriteborder.addframe(frameborderon);
			spritebutton.addframe(framebuttonoff);
			spritebutton.addframe(framebuttonon);
			spritebuttoncircle.addframe(framebuttoncircle);
		    
			frameWave1n1.load("sprites"+  File.separator + "waves/wave1-1.png");
			frameWave1n2.load("sprites"+  File.separator + "waves/wave1-2.png");
			frameWave1n3.load("sprites"+  File.separator + "waves/wave1-3.png");
			frameWave1n4.load("sprites"+  File.separator + "waves/wave1-4.png");
			frameWave1n5.load("sprites"+  File.separator + "waves/wave1-5.png");
			
			frameWave2n1.load("sprites"+  File.separator + "waves/wave2-1.png");
			frameWave2n2.load("sprites"+  File.separator + "waves/wave2-2.png");
			frameWave2n3.load("sprites"+  File.separator + "waves/wave2-3.png");
			frameWave2n4.load("sprites"+  File.separator + "waves/wave2-4.png");
			frameWave2n5.load("sprites"+  File.separator + "waves/wave2-5.png");
			
			frameWave3n1.load("sprites"+  File.separator + "waves/wave3-1.png");
			frameWave3n2.load("sprites"+  File.separator + "waves/wave3-2.png");
			frameWave3n3.load("sprites"+  File.separator + "waves/wave3-3.png");
			frameWave3n4.load("sprites"+  File.separator + "waves/wave3-4.png");
			frameWave3n5.load("sprites"+  File.separator + "waves/wave3-5.png");
			
			frameBackgroundSelectSong.load("sprites"+  File.separator + "pianoselectsong.png");
			spriteBackgroundSelectSong.addframe(frameBackgroundSelectSong);
			
			frameBackgroundMain.load("sprites"+  File.separator + "pianointro.png");
			spriteBackgroundMain.addframe(frameBackgroundMain);
			
			frameBackgroundOptions.load("sprites"+  File.separator + "pianooptions.png");
			spriteBackgroundOptions.addframe(frameBackgroundOptions);
			
			frameBackgroundNotebook.load("sprites"+  File.separator + "notebook.png");
			spriteBackgroundNotebook.addframe(frameBackgroundNotebook);
			
			frameHand.load("sprites"+  File.separator + "hand.png");
			spriteHand.addframe(frameHand);
			
			spriteWave.addframe(frameWave1n1);
			spriteWave.addframe(frameWave1n2);
			spriteWave.addframe(frameWave1n3);
			spriteWave.addframe(frameWave1n4);
			spriteWave.addframe(frameWave1n5);
		    
			spriteWave.addframe(frameWave2n1);
			spriteWave.addframe(frameWave2n2);
			spriteWave.addframe(frameWave2n3);
			spriteWave.addframe(frameWave2n4);
			spriteWave.addframe(frameWave2n5);
			
			spriteWave.addframe(frameWave3n1);
			spriteWave.addframe(frameWave3n2);
			spriteWave.addframe(frameWave3n3);
			spriteWave.addframe(frameWave3n4);
			spriteWave.addframe(frameWave3n5);
		    
		    
		    frameCrotchet.load("sprites"+  File.separator + "crotchet.png");
		    spriteCrotchet.addframe(frameCrotchet);
		    
			frameNoteStaffwhole.load("sprites"+  File.separator + "whole.png");
			frameNoteStaffhalf.load("sprites"+  File.separator + "half.png");
			frameNoteStaffquarter.load("sprites"+  File.separator + "quarter.png");
			frameNoteStaffeighth.load("sprites"+  File.separator + "eighth.png");
			frameNoteStaffsixteenth.load("sprites"+  File.separator + "sixteenth.png");
			
			frameNoteStaffAuxLine.load("sprites"+  File.separator + "auxline.png");
			
			spriteNoteStaff.addframe(frameNoteStaffwhole);
			spriteNoteStaff.addframe(frameNoteStaffhalf);
			spriteNoteStaff.addframe(frameNoteStaffquarter);
			spriteNoteStaff.addframe(frameNoteStaffeighth);
			spriteNoteStaff.addframe(frameNoteStaffsixteenth);
			
			spriteNoteStaffAuxLine.addframe(frameNoteStaffAuxLine);
		    
		    frameCrotchetBorder.load("sprites"+  File.separator + "crotchetborder.png");
		    spriteCrotchetBorder.addframe(frameCrotchetBorder);
		    
		    frameStaff.load("sprites"+  File.separator + "staff.png");
		    spriteStaff.addframe(frameStaff);
		    
		    frameNoteYellow.load("sprites"+  File.separator + "noteyellow.png");
		    frameNotePurple.load("sprites"+  File.separator + "notepurple.png");
		    frameNotePink.load("sprites"+  File.separator + "notepink.png");
		    frameNoteRed.load("sprites"+  File.separator + "notered.png");
		    frameNoteOrange.load("sprites"+  File.separator + "noteorange.png");
		    frameNoteBlue.load("sprites"+  File.separator + "noteblue.png");
		    
		    
		    spriteNote.addframe(frameNoteYellow);
		    spriteNote.addframe(frameNotePurple);
		    spriteNote.addframe(frameNoteRed);
		    spriteNote.addframe(frameNotePink);
		    spriteNote.addframe(frameNoteOrange);
		    spriteNote.addframe(frameNoteBlue);
		    
		   
		    
			 frameOk.load("sprites"+  File.separator + "ok.png");
			 frameBad.load("sprites"+  File.separator + "bad.png");
			 framePerfect.load("sprites"+  File.separator + "perfect.png");
			 
			 spriteTemp.addframe(frameOk);
			 spriteTemp.addframe(frameBad);
			 spriteTemp.addframe(framePerfect);
		    
		    for (int i=0;i<10;i++){

		    	spritePrecision[i] = new CSprite();
		    	
		    	spritePrecision[i].addframe(frameOk);
		    	spritePrecision[i].addframe(frameBad);
		    	spritePrecision[i].addframe(framePerfect);
		    }
			 
		    frameKey.load("sprites"+  File.separator + "key.png");
		    frameKeyPush.load("sprites"+  File.separator + "keypush.png");
		    spriteKey.addframe(frameKey);
		    spriteKey.addframe(frameKeyPush);
		    
		    frameKeyblack.load("sprites"+  File.separator + "keyblack.png");
		    frameKeyblackPush.load("sprites"+  File.separator + "keyblackpush.png");
		    spriteKeyblack.addframe(frameKeyblack);
		    spriteKeyblack.addframe(frameKeyblackPush);
		    
		    frameLine.load("sprites"+  File.separator + "line.png");
		    spriteLine.addframe(frameLine);
		    
		    frameNoteBorder.load("sprites"+  File.separator + "noteborder.png");
		    spriteNoteBorder.addframe(frameNoteBorder);

		}
		
		public void initgame() throws Exception{ //inicializa
			
			menu = 1;
			submenu = 1;
			maxsubmenu = 3;
			piano = new Piano();
			
			//piano.getdevices();
			piano.init();
			
			online = 0;
			
		//	language = new Language();
			//language.load();
			
			frameskip = 0;
			frameskipmax = 0;
			
			player = new MidiPlayer();
			window = new Window();
			score = new Score();
			song = "";
			newusername = "";
			interval = 7500;
			actualwave = 0;
			
			
			maxusermenu = 3;
			maxoption=4;
			
			fullscreen=false;
			
			numuser = 0;
			nummenu=0;
			
			maxmenu=4;
			
			staffmode =0;
			
			end = false;
			user = new User();
	  	    filebrowser = new FileBrowser();
	  	    
	  	    numfile = 0; 
	  	    
	  	    numoption = 0;
	  
		    menuselectmusic=0;
		    
		    menuprincipal=0;
	  	    
	  	    maxprecision = 10; //mensajes de bad, ok, perfect en pantalla
	  	    maxkey = 25;       //numero de teclas, blancas y negras por separado
	  	    
	  	  maxKeys = 30;       //numero de teclas, blancas y negras por separado
	  	    
	  	    maxnotes = 50; //numero de notas simultaneas en pantalla
	  	    maxtracks = 20; //maximo numero de tracks por midi
	  	    maxchannel = 5; //maximo numero de canales de sonido (sonidos simultáneos)
	  	    
	  	    //MixChunk chunk= SDLMixer.loadWAV("sound/wav.wav");
	  	    //  Mix_Chunk chunk = SWIG_SDLMixer.SWIG_Mix_LoadWAV("sound/wav.wav");
	  	    		   
		    keyboard = new Keyboard();
		    
		   // MixChunk chunk= SDLMixer.loadWAV("sound/wav.wav");
		    
		    SDLTTF.init();
		    text = new Text();
		    text.init("fonts"+  File.separator + "FreeSerif.ttf");
		    
		    textCalculator20 = new Text();
		    textCalculator20.init("fonts"+  File.separator + "calculator.ttf");
		    textCalculator20.setcolor(47, 131, 43);
		    
		    textCalculator40 = new Text();
		    textCalculator40.init("fonts"+  File.separator + "calculator.ttf",40);
		    textCalculator40.setcolor(47, 131, 43);
		    
		    textCalculator15 = new Text();
		    textCalculator15.init("fonts"+  File.separator + "calculator.ttf",15);
		    textCalculator15.setcolor(47, 131, 43);
		    
		    textArial15 = new Text();
		    textArial15.init("fonts"+  File.separator + "arial.ttf",15);
		    textArial15.setcolor(255, 255,255);
		    
		    textArabica10 = new Text();
		    textArabica10.init("fonts"+  File.separator + "arabica.ttf",10);

		    textArabica10.setcolor(87, 88,90);
		    
		    textArabica8 = new Text();
		    textArabica8.init("fonts"+  File.separator + "arabica.ttf",8);

		    textArabica8.setcolor(87, 88,90);
		    
		    textHand20 = new Text();
		    textHand20.init("fonts"+  File.separator + "brigitte.ttf",20);

		    textHand20.setcolor(0,0,0);
		    
		    pushKey = 0;

		}
		
	String actualUser ;
	
	User(){
		actualUser = "";
	}
	void setUser(String user){
		
		actualUser = user;
	}
	String getUser(){
		
		return actualUser;
	}
	void createUser(String name) throws IOException{
		
		
		boolean exists = (new File("filename")).exists();
		
		exists = new File("user" + File.separator + name ).exists();
		
		FileWriter write ;
		PrintWriter text ;
		
		/*
		 write = new FileWriter("score/" + name + ".txt");
		 text = new PrintWriter(write);
		 
		 text.println(String.valueOf(score));
		 
		 write.flush();
		 write.close();*/
		
		if ( ! exists ){
			System.out.println("crea nuevo usuario");
			 write = new FileWriter("users" + File.separator + name);
			 //text = new PrintWriter(write);
			 
			 write.close();
			
		}
		else{
			//el usuario ya está creado
		}
		
	}
	public void draw(SDLSurface screen) throws SDLException{
		
		int maxusers = 10;
		int contusuarios =1;
		spriteBackgroundNotebook.draw(screen);
		int longitud;
		System.out.println(menu);
		if (menu == 1){ //listado de usuarios
		
			//añadir usuario
	    	//if (numuser == -1 ) textHand20.setcolor(255, 255, 0); 
	    	//else textHand20.setcolor(0, 0, 0);
	    	
	    	//listado de usuarios
	    	textHand20.drawtext(ResourceBundle.getBundle("Language").getString("Anadir"), screen, 320, 70 );
	    	while ( (contusuarios < filebrowser.getnumfiles("users") ) && (contusuarios<maxusers) ){
	    		
	    		if (numuser == contusuarios){
	
	    			//textHand20.setcolor(255, 255, 0);
	    			
	    		}
	    		else {
	    			//textHand20.setcolor(0, 0, 0);
	    		}
	    		textHand20.drawtext(filebrowser.getfile("users",contusuarios), screen,330, 100
	    				+(contusuarios*33)); 
	    		//System.out.println(filebrowser.getfile(i));
	    	  	
	    		contusuarios++;
	    	}
	    	textHand20.setcolor(0, 0, 0);
	    	
	    	if (numuser == 0){
				spritepencil.sety(80);
				spritepencil.setx(400);
			}
			else{
				longitud = filebrowser.getfile("users",numuser).length();
				
				spritepencil.setx(longitud*12+350);
				spritepencil.sety(numuser *33 + 110);
			
			}
			spritepencil.draw(screen);
		}

	  	if (menu == 3){ //seleccionar,modificar,borrar
			
	  		
			textHand20.drawtext(ResourceBundle.getBundle("Language").getString("Seleccionar"), screen, 320, 100+(0*33));
			textHand20.drawtext(ResourceBundle.getBundle("Language").getString("Modificar"), screen, 320, 100+(1*33));
			textHand20.drawtext(ResourceBundle.getBundle("Language").getString("Borrar"),screen, 320, 100+(2*33));
			
			longitud = Math.max(ResourceBundle.getBundle("Language").getString("Seleccionar").length(),ResourceBundle.getBundle("Language").getString("Modificar").length());
			longitud = Math.max(longitud,ResourceBundle.getBundle("Language").getString("Borrar").length());
			
			spritepencil.setx(longitud*12 +350);
			spritepencil.sety(submenu *33 + 80);
			spritepencil.draw(screen);
		}
	  	
	  	if (menu == 2){ //nuevo usuario

			textHand20.drawtext("Nuevo nombre de usuario: ", screen, 320, 440);
			textHand20.drawtext(" " +newusername, screen, 330,480);
			
			longitud = newusername.length();
			
			spritepencil.setx(longitud*12 +340);
			spritepencil.sety( 500);
			spritepencil.draw(screen);
		}
	  	
		screen.flip(); //Pintamos la pantalla
 	   
	  	screen.fillRect(0); //borramos la pantalla anterior
	
	}
	int go (SDLSurface screen){
		
		try{
			
			this.initsprites();
			this.initgame();
			this.initobjects();
		}
		catch (Exception e){
			
		}
		this.end = false;
		while (!this.end){
			
			try {
				this.draw(screen);

				this.keyboard();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return 0;
	}
	public void keyboard() throws InvalidMidiDataException, IOException, MidiUnavailableException, SDLException, InterruptedException {
		pushKey = keyboard.keynumber(); //detecta el teclado

		
		
		if (menu == 1){ //selección de usuario
	    	switch (pushKey){
	    	
		    	case -2 : 
		   
		    		this.end = true;
		    		
		    		break;
	    	
		    	case 201:
		    		
		    		if (numuser >0 ){
		    			numuser--;
		    		}
		    		break;
		    	case 202:
		    		if (numuser+1 < filebrowser.getnumfiles("users")){
		    			numuser++;
		    		}
		    		break;
		    	case 300:
		    		
		    		if (numuser == 0 ){
		    			
		    			menu = 2;
		    			
		    			newusername = ""; //nueva cadena
		    		}
		    		if (numuser > 0 ){

		    			menu = 3;

		    		}
		    		
		    		//song = filebrowser.getfile(numuser);
		    		//initsong(song);
	
		    		break;
	    	}
		}
		else if (menu == 2){ //introduccion nuevo usuario
			
			int key;
			boolean finishname = false;
			
			char c = ' ';
			if(finishname == false){
				
				key = keyboard.readKeyboard();
				if (key == 303 ){ //shift (detecta pulsacion  y liberacion)
					if (shift == 32){
						shift = 0;
					}
					else {
						shift = 32;
					}
					
				}
				if (key == 301 ){ //Bloq mayus
					if (shift == 32){
						shift = 0;
					}
					else {
						shift = 32;
					}
			
				}

				if (key == 13){ //enter

					user.createUser(newusername);
					finishname = true;
					menu=1;
					keyboard.waitrelease();
				}
				if (key == 27){ //scape
					finishname = true;
					menu=1;
					keyboard.waitrelease();
				}
				if (  ((key >=48 ) && (key <=57 )) || //1-0
						(key == 32) //space
						){
					c = (char)key;
					
					
					newusername = newusername + c;
					
				}
				if ((key >=97 ) && (key <=122)){
					c = (char) (key-shift);
					newusername = newusername + c;
				}
				
				if ((key == 8) && (newusername.length()>0) ){ //backspace
					newusername = (String) newusername.subSequence(0, newusername.length() - 1);
					
				}
				
			}

		}
		else if (menu ==3){
			
	    	switch (pushKey){
	    	
		    	case -2 : 
		    		
		    		menu=1;
		    		keyboard.waitrelease();
		    		break;
	    	
		    	case 201:
		    		if (submenu > 1 ){
		    			submenu--;
		    		}
		    		break;
		    	case 202:
		    		if (submenu < maxsubmenu ){
		    			submenu++;
		    		}
		    		break;
		    	case 300:

		    		if (menu == 1){//activar
		    			
		    			user.setUser(filebrowser.getfile("users", numuser));
		    		}
		    		if (menu == 2){ //modificar
		    				
		    		}
		    		if (menu == 3){ //borrar
		    			filebrowser.deletefile("users", numuser);
		    		}
		    		menu=1;
		    		//song = filebrowser.getfile(numuser);
		    		//initsong(song);
	
		    		break;
		    }
		}
	    	
	}
	
}
